SystemOrganization addCategory: #ConfigurationOfSDL!

Object subclass: #ConfigurationOfSDL
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSDL'!

!ConfigurationOfSDL class methodsFor: 'development support' stamp: 'NickAlexander 1/8/2012 20:28'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSDL class methodsFor: 'private' stamp: 'NickAlexander 1/8/2012 20:28'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSDL class methodsFor: 'private' stamp: 'NickAlexander 1/8/2012 20:28'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSDL class methodsFor: 'private' stamp: 'NickAlexander 1/8/2012 20:28'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSDL class methodsFor: 'metacello tool support' stamp: 'NickAlexander 1/8/2012 20:28'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSDL class methodsFor: 'loading' stamp: 'NickAlexander 1/8/2012 20:28'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSDL class methodsFor: 'loading' stamp: 'NickAlexander 1/8/2012 20:28'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSDL class methodsFor: 'loading' stamp: 'NickAlexander 1/8/2012 20:28'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSDL class methodsFor: 'accessing' stamp: 'NickAlexander 1/8/2012 20:28'!
project

	^self new project! !

!ConfigurationOfSDL class methodsFor: 'development support' stamp: 'NickAlexander 1/8/2012 20:28'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSDL methodsFor: 'baselines' stamp: 'NickAlexander 1/8/2012 21:42'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/SDL'.
		spec 
			project: 'XMLSupport' with: [
				spec
					className: 'ConfigurationOfXMLSupport';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/XMLSupport' ];
			project: 'FFI' with: [
				spec
					className: 'ConfigurationOfFFI';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'NativeBoost' with: [
				spec
					className: 'ConfigurationOfNativeBoost';
					versionString: #'bleedingEdge';
					file: 'NativeBoost-Installer';
					repository: 'http://www.squeaksource.com/NativeBoost' ].
		spec 
			package: 'Phexample' with: [
				spec repository: 'http://www.squeaksource.com/phexample' ];
			package: 'Pastell' with: [
				spec requires: #('XMLSupport' ). ];
			package: 'SDL-FFI' with: [
				spec requires: #('FFI' ). ];
			package: 'SDL-Tests-FFI' with: [
				spec requires: #('SDL-FFI' 'Phexample' ). ];
			package: 'SDL-Specs-Core' with: [
				spec requires: #('XMLSupport' 'Pastell' ). ];
			package: 'SDL-Specs-FFI' with: [
				spec requires: #('SDL-Specs-Core' 'FFI' ). ];
			package: 'SDL-Specs-NB' with: [
				spec requires: #('SDL-Specs-Core' 'NativeBoost' ). ].
		spec group: 'default' with: #('SDL-FFI' ). ].
! !

!ConfigurationOfSDL methodsFor: 'symbolic versions' stamp: 'NickAlexander 1/8/2012 21:16'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfSDL methodsFor: 'accessing' stamp: 'NickAlexander 1/8/2012 20:28'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSDL methodsFor: 'versions' stamp: 'NickAlexander 1/8/2012 21:16'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial development version'.
		spec author: 'NickAlexander'.
		spec timestamp: '1/8/2012 21:16'.
		spec 
			project: 'XMLSupport' with: #'stable';
			project: 'FFI' with: '1.5';
			project: 'NativeBoost' with: '1.0.3'.
		spec 
			package: 'Phexample' with: 'Phexample-NikoSchwarz.63';
			package: 'Pastell' with: 'Pastell-NickAlexander.19';
			package: 'SDL-FFI' with: 'SDL-FFI-NickAlexander.3';
			package: 'SDL-Tests-FFI' with: 'SDL-Tests-FFI-NickAlexander.1';
			package: 'SDL-Specs' with: 'SDL-Specs-NickAlexander.8';
			package: 'SDL-Specs-FFI' with: 'SDL-Specs-FFI-NickAlexander.1';
			package: 'SDL-Specs-NB' with: 'SDL-Specs-NB-NickAlexander.1'. ].
! !
